/* 
 * File:     PaeSheep.cpp
 * Author:   MJW
 * Date:     23.03.2006
 * Modified: 23.03.2006
 *
 * Purpose: Sourcecode zur Klasse PaeSheep
 */
 
#include "PaeSheep.h"
#include "Utilities.h"
#include <math.h>


/*
 * Methodendefinitionen zur Klasse PaeSheep
 */



PaeSheep::PaeSheep(void){

  this->SetStandardParameters();
  
}

PaeSheep::PaeSheep(float x, float y, World *the_world){

  this->SetStandardParameters();

  my_world = the_world;
  
  pos[0] = x;
  pos[1] = y;
  pos[2] = my_world->terr->GetHeight(x,y);;

}



PaeSheep::~PaeSheep(){
  gluDeleteQuadric(leg_quadric);  
}




void PaeSheep::SetPosition(float x, float y, float z){

  pos[0] = x;
  pos[1] = y;
  pos[2] = z;
}




void PaeSheep::SetDirection(float x, float y, float z){

  dir[0] = x;
  dir[1] = y;
  dir[2] = z;
}




void PaeSheep::SetColor(GLfloat r, GLfloat g, GLfloat b){

  col[0] = r;
  col[1] = g;
  col[2] = b;
}


void PaeSheep::Draw(void){

  /*
   * festlegen von Standardfarben
   */

  float angle;

  GLfloat white[3] = {1.0,1.0,1.0};
  GLfloat black[3] = {0.1,0.1,0.1};
  GLfloat grey[3]  = {0.3,0.3,0.3};

  GLfloat red[3]   = {1.0,0.0,0.0};
  GLfloat green[3] = {0.0,1.0,0.0};
  GLfloat blue[3]  = {0.0,0.0,1.0};

  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
    glTranslatef(pos[0],pos[1],pos[2]+1.0);
	angle = asin(-dir[1]);
	angle = angle*180.0/3.1415926;
	if(dir[0] > 0.0){
	  if (angle > 0.0){
		angle = 180-angle;
	  } else { 
		angle = -angle-180.0;
	  }
	}
	glRotatef(angle,0.0,0.0,1.0);
	glScalef(0.3,0.3,0.3);

	/*
	 * Koerper
	 */
    glPushMatrix();
      glColor3fv(col);
      glScalef(2.0,1.0,1.0);
      glutSolidSphere(1.0,10,10);
    glPopMatrix();


    /*
	 * Schwanz
	 */

    glPushMatrix();    
      glColor3fv(white);
	  glTranslatef(2.1,0.2,0.0);
	  glScalef(0.3,0.3,0.3);
	  glutSolidSphere(1.0,10,10);
    glPopMatrix();
         

    /*
	 * Kopf
	 */

	glPushMatrix();
      glColor3fv(grey);
	  glRotatef(10,0.0,0.0,1.0);
	  glTranslatef(-1.9,0.6,0.0);
	  glScalef(0.7,0.5,0.5);
	  glutSolidSphere(1.0,10,10); 
	glPopMatrix();
         

	glPushMatrix();
      glRotatef(180,1.0,0.0,0.0); 
	  gluQuadricDrawStyle(leg_quadric, GLU_FILL);

      /*
	   * ### Bein vorne links ###
	   */
	  glTranslatef(-0.75,0.25,0.9);
	  glColor3fv(white);
	  gluCylinder(leg_quadric, 0.1, 0.1, 0.5, 10, 10);

      /* ... mit Huf ... */
	  glTranslatef(0.0,0.0,0.4);
	  glColor3fv(black);
	  gluCylinder(leg_quadric, 0.11, 0.11, 0.15, 10, 10);


      /*
	   * ### Bein vorne rechts ###
	   */
	  glTranslatef(0.0,-0.5,-0.4);
	  glColor3fv(white);
	  gluCylinder(leg_quadric, 0.1, 0.1, 0.5, 10, 10);

      /* ... mit Huf ... */
	  glTranslatef(0.0,0.0,0.4);
	  glColor3fv(black);
	  gluCylinder(leg_quadric, 0.11, 0.11, 0.15, 10, 10);


      /*
	   * ### Bein hinten links ###
	   */
	  glTranslatef(1.3,0.5,-0.4);
	  glColor3fv(red);
	  gluCylinder(leg_quadric, 0.1, 0.1, 0.5, 10, 10);

      /* ... mit Huf ... */
	  glTranslatef(0.0,0.0,0.4);
	  glColor3fv(black);
	  gluCylinder(leg_quadric, 0.11, 0.11, 0.15, 10, 10);


      /*
	   * ### Bein hinten rechts ###
	   */
	  glTranslatef(0.0,-0.5,-0.4);
	  glColor3fv(white);
	  gluCylinder(leg_quadric, 0.1, 0.1, 0.5, 10, 10);

      /* ... mit Huf ... */
	  glTranslatef(0.0,0.0,0.4);
	  glColor3fv(black);
	  gluCylinder(leg_quadric, 0.11, 0.11, 0.15, 10, 10);

	glPopMatrix();
             
  glPopMatrix();
}


void PaeSheep::Draw2(void){

  glPushMatrix();     
    glColor3f(1.0,1.0,1.0);
    glTranslatef(pos[0],pos[1],pos[2]);
    glutSolidSphere (0.3, 10, 10); 
    glTranslatef(dir[0],dir[1],0);
    glutSolidSphere (0.2, 10, 10); 
  glPopMatrix();   
}

void PaeSheep::Think(void){

  acc[0] = PaeRand(-0.05,0.05);
  acc[1] = PaeRand(-0.05,0.05);
  acc[2] = 0.0;

}
  
void PaeSheep::Move(void){
  float len;
     
  dir[0] += acc[0];
  dir[1] += acc[1]; 
  dir[2] += acc[2];
    
  len = PaeRenorm3(dir); 
  
  v *= len;
  if(v >0.5){
    v = 0.5;
  } else if (v <0.01){
    v = 0.01;
  }
    
  pos[0] += dir[0]*v;
  pos[1] += dir[1]*v;
  pos[2] += dir[2]*v;
  
}
  

void PaeSheep::SetStandardParameters(void){
  float angle;

  my_world = NULL;

  pos[0] = 0.0;
  pos[1] = 0.0;
  pos[2] = 0.0;
  

  angle = PaeRand(-3.1415926,3.1415926);
  dir[0] = sin(angle);
  dir[1] = cos(angle);
  dir[2] = 0.0;

  acc[0] = 0.0;
  acc[1] = 0.0;
  acc[2] = 0.0;
  
  up[0] = 0.0;
  up[1] = 0.0;
  up[2] = 1.0;
  
  col[0] = 0.7;
  col[1] = 0.7;
  col[2] = 0.7;
  
  v = 0.1;

  leg_quadric = gluNewQuadric();
  
  nextsheep = NULL;
}


void PaeSheep::GetPosition(float *p){

  p[0] = pos[0];
  p[1] = pos[1];
  p[2] = pos[2];
}
  

void PaeSheep::InvertDirection(void){

  dir[0] = -dir[0];
  dir[1] = -dir[1];
  dir[2] = -dir[2];
}
  
