/* 
 * File:     PaeSheep.cpp
 * Author:   PAE
 * Date:     23.03.2006
 * Modified: 23.03.2006
 *
 * Purpose: Headerdatei zur Klasse PaeSheep
 */
 
#ifndef PAE_SHEEP_HEADER
#define PAE_SHEEP_HEADER

#include <iostream>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>

#include "Definitions.h"
#include "World.h"

using namespace std;

class World;

class PaeSheep{
 private:
  GLfloat pos[3];   // position 
  GLfloat dir[3];   // blickrichtung
  GLfloat acc[3];   // blickrichtung
  GLfloat up[3];    // wo ist oben?
  GLfloat v;
  
  GLfloat col[3];   // Zeichenfarbe
  GLUquadricObj *leg_quadric;
  World *my_world;
  

 public:
  PaeSheep *nextsheep;


  /*
   * 1. Konstruktoren
   */
  PaeSheep(void);                               // Standardkonstruktor
  PaeSheep(float x, float y, World *the_world); // erweiterter Konstruktor


  /*
   * 2. Destruktoren
   */
  ~PaeSheep();                                  // Standarddestruktor

  /*
   * 3. Modifizierer
   */
  void SetPosition(float x, float y, float z);      // Setzt die Position
  void SetDirection(float x, float y, float z);     // Setzt die Richtung 
  void SetColor(GLfloat r, GLfloat g, GLfloat b);   // Setzt die Zeichenfarbe
  void Think(void);
  void Move(void);
  void SetStandardParameters(void);
  void InvertDirection(void);


  void Draw(void);  // Zeichnet das Schaf  
  void Draw2(void);  // Zeichnet das Schaf  
  

  /*
   * 4. Selektoren
   */
  void GetPosition(float *p);

};

#endif // PAE_SHEEP_HEADER

