#include "PaeWulf.h"

PaeWulf::PaeWulf(World *w){
   
   my_world = w;
   
   pos[0] = PaeRand(0.0,99.0);
   pos[1] = PaeRand(0.0,99.0);
   pos[2] = w->GetHeight(pos[0], pos[1]);
   
   dir[0] = 0.0;
   dir[1] = 1.0;
   dir[2] = 0.0;
   
   up[0] = 0.0;
   up[1] = 0.0;
   up[2] = 1.0;
   
   acc[0] = 0.0;
   acc[1] = 0.0;
   acc[2] = 0.0;
   
   col[0] = 0.3;
   col[1] = 0.3;
   col[2] = 0.3;
   
   mass = 5.0;
   
   nextwulf = NULL;
   
   state = JAGD;
}


void PaeWulf::SetPosition(GLfloat x, GLfloat y, GLfloat z){
  pos[0] = x;     
  pos[1] = y;
  pos[2] = z;
}


void PaeWulf::SetDirection(GLfloat x, GLfloat y, GLfloat z){
  dir[0] = x;
  dir[1] = y;
  dir[2] = z;
}

void PaeWulf::SetColor(GLfloat r, GLfloat g, GLfloat b){
  col[0] = r;
  col[1] = g;
  col[2] = b;
}


void PaeWulf::Think(void){
float *pos_sheep;
float len;
  pos_sheep = new float[3];
  if(state == JAGD){
    
    this->SetColor(1.0,0.0,0.0);//ein jagender wolf ist rot
    
    pos_sheep = my_world->nextSheep(this);
    acc[0] = -pos[0] + pos_sheep[0];
    acc[1] = -pos[1] + pos_sheep[1];
    acc[2] = -pos[2] + pos_sheep[2];
    
    len = PaeRenorm3(acc);
    
    //ist das tier sehr nahe am ziel, bremst es ab
    if(len < 1.0){
      v = 0.2;
    }
        
  }else if(state == SCHLAF){
    this->SetColor(0.0,0.0,1.0);//ein schlafender wolf ist blau
        
    acc[0] = 0.0;
    acc[1] = 0.0;
    acc[2] = 0.0;
    if(schlafzeit <= 0){
      state = JAGD;
    }
  }
  delete pos_sheep;
}


void PaeWulf::Act(void){
float len, dist;
float *pos_sheep;

  pos_sheep = new float[3];
  
  if(state == SCHLAF){
    //nichts passiert
    schlafzeit--;
    v = 0.0;
  }else if(state == JAGD){
    //das tier jagt
    dir[0] += acc[0];
    dir[1] += acc[1];
    dir[2] += acc[2];
    
    len = PaeRenorm3(dir);
    
    v*=len;
    
    if(v > MAXSPEED){
      v = MAXSPEED;
    }else if(v < 0.01){
      v = 0.02;
    }
    
    pos[0] += dir[0] * v;
    pos[1] += dir[1] * v;
    pos[2] += dir[2] * v;
    
    pos[2] = my_world->GetHeight(pos[0], pos[1]);
    
    //das tier nimmt ab wenn es rennt
    mass -= ABNAHME;
    
    pos_sheep = my_world->nextSheep(this);
    dist = (pos_sheep[0] - pos[0]) * (pos_sheep[0] - pos[0]) + (pos_sheep[1] - pos[1]) * (pos_sheep[1] - pos[1]);
    if(dist < JAGDABSTAND){
      //wenn wolf und schaf nahe genug sind
      if(my_world->KillSheep(pos_sheep)){
        //hat es erfolgreich gejagt, nimmt es zu
        mass += ZUNAHME;
        state = SCHLAF;
        schlafzeit = SCHLAFZEIT+(int)PaeRand(-SCHLAFDELTA, SCHLAFDELTA);
      }
    }
  }
  
  delete pos_sheep;
  
}


void PaeWulf::Draw(void){
  glPushMatrix();
    glTranslatef(pos[0], pos[1], pos[2]+0.5);
    glColor3fv(col);
    glutSolidSphere(1.0,10,10);
  glPopMatrix();
}

