/* 
 * File:     Stone.cpp
 * Author:   MJW
 * Date:     31.03.2006
 * Modified: 31.03.2006
 *
 * Purpose: Sourcecode zur Stone-Klasse
 */
 
#include "Stone.h"
#include "Utilities.h"

Stone::Stone(void){

  pos[0] = 0.0;
  pos[1] = 0.0;
  pos[2] = 0.0;
}


void Stone::Draw(void){

  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glColor3f(0.2,0.2,0.2);
    glTranslatef(pos[0],pos[1],pos[2]);
    glScalef(3.0,3.0,1.0);    
    glutSolidSphere(1.0,10,10);
  glPopMatrix();
}


void Stone::SetPosition(float x, float y, float z){

  pos[0] = x;
  pos[1] = y;
  pos[2] = z;
}



BasicInfo *Stone::SheepInfo(PaeSheep *the_sheep){
 
  float pos_sheep[3];
  float delta[3];
  float dist;

  BasicInfo *information;

  the_sheep->GetPosition(pos_sheep);

  delta[0] =  pos_sheep[0]-pos[0];
  delta[1] =  pos_sheep[1]-pos[1];
  delta[2] =  pos_sheep[2]-pos[2];

  dist = PaeRenorm3(delta);

  information = new BasicInfo(dist,delta);

  return(information);
}

