/* 
 * File:     World.cpp
 * Author:   NMM
 * Date:     12.03.2006
 * Modified: 27.03.2006
 *
 * Purpose: Definitionen der Klasse World
 */
 
#include "World.h"

#define STARTING_SHEEP 100 


//Funktionen der Klasse Simulation

World::World(){
  int i;
  PaeSheep *this_sheep;
  PaeWulf *this_wulf, *current_wulf;
    
  /*
   * Construct the terrain
   */
  terr = new PaeTerrain();                       
  terr->ScaleTerrain(-5.0, 5.0);
  terr->ReBuildNormals();


  /* 
   * Add sheep to the sheep list
   */
   
  firstsheep = NULL;
  CreateSheep(100);
  
  //6 woelfe
  firstwulf = new PaeWulf(this);
  current_wulf = firstwulf;
  for(i = 0; i < 5; i++){
    this_wulf = new PaeWulf(this);
    current_wulf->nextwulf = this_wulf;
    current_wulf = this_wulf;
  }

  /*
   * One experimental Stone
   */
  stone = new Stone();
  stone->SetPosition(20.0,30.0,2.0);

  cout << "World created!" << endl;

}


void World::CreateSheep(){

  CreateSheep(1);

}

void World::CreateSheep(int n){

    PaeSheep *new_sheep;
    PaeSheep *last_sheep;
    float x;
    float y;

	/*
	 * Keine Schafe => Bye-bye
	 */

	if(n <= 0 ){
	  return;
	}


	/*
	 * We look for the last sheep in the list
	 */
	last_sheep = NULL;
    new_sheep = firstsheep;
    while(new_sheep != NULL){
      last_sheep = new_sheep;
	  new_sheep = new_sheep->nextsheep;
    }


	/*
	 * last_sheep is now NULL or pointing to the last sheep
	 */
	if(last_sheep == NULL){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  firstsheep = new PaeSheep(x,y,this);
	  last_sheep = firstsheep;
	  n--;
	}


	/*
	 * last_sheep is pointing to the last sheep
	 */

	for(int i=0;i<n;i++){
	  x = PaeRand(0.0,99.0);
	  y = PaeRand(0.0,99.0);
	  last_sheep->nextsheep = new PaeSheep(x,y,this);
	  last_sheep = last_sheep->nextsheep;
	}
}





void World::Draw(){
  PaeSheep *this_sheep;
  PaeWulf *this_wulf;
  int i;
  i=0;
  
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
    terr->Draw();
  glPopMatrix();

  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
    stone->Draw();
  glPopMatrix();

  this_sheep = firstsheep;
  while(this_sheep != NULL){       //sage jedem Schaf, dass es sich zeichnen soll
    i++;
    glMatrixMode(GL_MODELVIEW);
    glPushMatrix();
      this_sheep->Draw();
    glPopMatrix();
    this_sheep = this_sheep->nextsheep;
	
  }
  this_wulf = firstwulf;
  while(this_wulf != NULL){
    this_wulf->Draw();
    this_wulf = this_wulf->nextwulf;
  }
  
  

}









void World::Prepare(){
     PaeSheep *this_sheep;
     PaeWulf *this_wulf;
     this_sheep = firstsheep;
     while(this_sheep != NULL){
       this_sheep->Think();
       this_sheep = this_sheep->nextsheep;
     }  
     this_wulf = firstwulf;
     while(this_wulf != NULL){
       this_wulf->Think();
       this_wulf = this_wulf->nextwulf;
     }    
        
}

void World::Action(){
  float cur_pos[3];
  int invert_flag;
  PaeSheep *this_sheep;
  PaeWulf *this_wulf;

  terr->GrowFood();

  this_sheep = firstsheep;
  while(this_sheep != NULL){
    this_sheep->Move();
	
	/*
	 * If sheep leaves terrain, turn it around!
	 */
	invert_flag = false;
	this_sheep->GetPosition(cur_pos);
	if (cur_pos[0] < 0.0){
	  cur_pos[0] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[0] >= 99.0){
	  cur_pos[0] = 98.9;
	  invert_flag = true;
	}
	if (cur_pos[1] < 0.0){
	  cur_pos[1] = 0.1;
	  invert_flag = true;
	}
	if (cur_pos[1] >= 99.0){
	  cur_pos[1] = 98.9;
	  invert_flag = true;
	}
	if(invert_flag){
	  this_sheep->InvertDirection();
	}

	/*
	 * Put sheep to the right height
	 */
	cur_pos[2] = terr->GetHeight(cur_pos[0],cur_pos[1]);
	this_sheep->SetPosition(cur_pos[0],cur_pos[1],cur_pos[2]);
	
	/*
	 * next, please!
	 */
    this_sheep = this_sheep->nextsheep;
  }         
  this_wulf = firstwulf;
  while(this_wulf != NULL){
       this_wulf->Act();
       this_wulf = this_wulf->nextwulf;
  } 
}

float World::GetHeight(float x, float y){
      return terr->GetHeight(x,y);
}



float* World::nextSheep(PaeWulf *w){
float *sheep_pos, *pos;
float dist = 100000.0, temp;
  sheep_pos = new float[3];  //die position eines schafes
  pos = new float[3];        //die position des naechsten schafes wird hier gespeichert
  
  PaeSheep *this_sheep;
  
  this_sheep = firstsheep;
  
  //wenn es keine schafe mehr gibt werden die woelfe in die irre gelockt
  pos[0] = PaeRand(0.0,99.0);
  pos[1] = PaeRand(0.0,99.0);
  pos[2] = 0.0;
  
  while(this_sheep != NULL){
    this_sheep->GetPosition(sheep_pos);
    temp = (sheep_pos[0] - w->pos[0])*(sheep_pos[0] - w->pos[0]) + (sheep_pos[1] - w->pos[1])*(sheep_pos[1] - w->pos[1]);
    if(temp < dist){
      dist = temp;
      pos[0] = sheep_pos[0];
      pos[1] = sheep_pos[1];
      pos[2] = sheep_pos[2];
    }
    this_sheep = this_sheep->nextsheep;
  }
  
  return pos;
}
   

//toetet ein schaf an ungefaher der angagabenen position
bool World::KillSheep(float *p){
PaeSheep *this_sheep, *last_sheep;
float *pos, dist;

  pos = new float[3];
    
  last_sheep = firstsheep;
  if(last_sheep != NULL){
    this_sheep = last_sheep->nextsheep;
  }
  //das erste schaf wird separat ueberprueft
  last_sheep->GetPosition(pos);
  dist = (p[0] - pos[0]) * (p[0] - pos[0]) + (p[1] - pos[1]) * (p[1] - pos[1]);
  if(dist < JAGDABSTAND){
    firstsheep = last_sheep->nextsheep;
    delete last_sheep;
    delete pos;
    return true;
  }
  
  while(this_sheep != NULL){
    this_sheep->GetPosition(pos);
    dist = (p[0] - pos[0]) * (p[0] - pos[0]) + (p[1] - pos[1]) * (p[1] - pos[1]);
    if(dist < JAGDABSTAND){
      last_sheep->nextsheep = this_sheep->nextsheep;
      delete this_sheep;
      delete pos;
      return true;
    }
    last_sheep = this_sheep;
    this_sheep = this_sheep->nextsheep;
  }
  
  delete pos;
  return false;
}
